-- Ŀ
--  Psuedo Windows Kernal  V1.00 (C) 1996 Faversham Information Technology    
--  Special pre-release for Rob Craig @ Rapid Deployment Software. Use freely 
-- 
include machine.e

global integer ScreenWidth,ScreenHight,ScreenDepth
global integer Mouse,MouseX,MouseLX,MouseY,MouseLY,MouseB
global integer ZoneXl, ZoneXr, ZoneYt, ZoneYb, ZoneMax, ZoneCnt, ZoneIdx
global sequence Zone, SystemZone
global sequence MouseVixels
MouseVixels =
  {
  { 0, 0,0},
  {-5, 0,0},{-4, 0,0},{-3, 0,0},{ 3, 0,0},{ 4, 0,0},{ 5, 0,0},
  { 0,-5,0},{ 0,-4,0},{ 0,-3,0},{ 0, 3,0},{ 0, 4,0},{ 0, 5,0}
  }


global sequence regin,regout
regin =  {0,0,0,0,0,0,0,0,0,0}
regout = {0,0,0,0,0,0,0,0,0,0}
Zone = {} -- Zone[l][r][t][b][tsk]
ZoneMax = 0     ZoneIdx = 0     ZoneCnt = 1


global function SetupMouse(integer xmax,integer ymax)
  Mouse = 0
  regin[REG_AX] = 0 -- Initialise mouse
  regout = dos_interrupt(#33,regin)
  if regout[REG_AX] != 0 then
    regin[REG_AX] = 2 -- Hide mouse pointer
    regout = dos_interrupt(#33,regin)
    
    regin[REG_AX] = 7 -- Set X min & max
    regin[REG_CX] = 0
    regin[REG_DX] = xmax - 1
    regout = dos_interrupt(#33,regin)
    
    regin[REG_AX] = 8 -- Set Y min & max
    regin[REG_CX] = 0
    regin[REG_DX] = ymax - 1
    regout = dos_interrupt(#33,regin)
    
    MouseX = 0
    MouseY = 0
    MouseB = 0
    Mouse = 1
  else
    if graphics_mode(-1) then
    end if
    printf(1,"No mouse ! \n",{})
    abort(1)
  end if
  return Mouse
end function

global procedure GetMouseXYB()
  if Mouse > 0 then
    regin[REG_AX] = 3 -- Get mouse X,Y & buttons
    regout = dos_interrupt(#33,regin)
    MouseLX = MouseX
    MouseLY = MouseY
    MouseX  = regout[REG_CX]
    MouseY  = regout[REG_DX]
    MouseB  = regout[REG_BX]
  end if
end procedure

global function OpenWindow(sequence title)
  sequence vc
  integer m
  vc = video_config()
  if vc[VC_MODE] < 250 then
    if graphics_mode(259) then
	puts(1, "bad graphics mode\n")
	abort(1)
    end if
    vc = video_config()
  end if
  ScreenWidth = vc[VC_XPIXELS]
  ScreenHight = vc[VC_YPIXELS]
  ScreenDepth = vc[VC_NCOLORS]
  m = SetupMouse(ScreenWidth,ScreenHight)
  return m
end function


global procedure GetUnderImage(integer x,integer y)
  integer l,xx,yy
  l = length(MouseVixels)
  for c = 1 to l do
    xx = x + MouseVixels[c][1]
    yy = y + MouseVixels[c][2]
    MouseVixels[c][3] = get_pixel({xx,yy})
  end for
end procedure

global procedure PutUnderImage(integer x,integer y)
  integer l,xx,yy
  l = length(MouseVixels)
  if Mouse > 1 then
    for c = 1 to l do
      xx = x + MouseVixels[c][1]
      yy = y + MouseVixels[c][2]
      pixel(MouseVixels[c][3],{xx,yy})
    end for
  else
    Mouse = 2
  end if
end procedure

global procedure DrawPointer(integer x,integer y,integer p)
  integer l,xx,yy
  l = length(MouseVixels)
  for c = 1 to l do
    xx = x + MouseVixels[c][1]
    yy = y + MouseVixels[c][2]
    pixel(p,{xx,yy})
  end for
end procedure

global procedure PointingDevice(integer mc)
  integer l,r,t,b
  
  GetMouseXYB()  
  if (MouseX != MouseLX) or (MouseY != MouseLY) then
    PutUnderImage(MouseLX,MouseLY)
    GetUnderImage(MouseX,MouseY)
    DrawPointer(MouseX,MouseY,mc)
  end if

  if MouseB > 1 then
      ZoneIdx = 0 -- Start Zone scan
  end if

  if (ZoneIdx < 1) and (ZoneMax > 0) then
    l = Zone[ZoneCnt][1]
    r = Zone[ZoneCnt][2]
    t = Zone[ZoneCnt][3]
    b = Zone[ZoneCnt][4]
    if (MouseX > l) and (MouseX < r) and (MouseY > t) and (MouseY < b) then
      draw_line(15,{ {l,t},{r,t},{r,b},{l,b},{l,t} })
      ZoneIdx = ZoneCnt
      --Task = Zone[ZoneIdx][5]
    else
      draw_line(7,{ {l,t},{r,t},{r,b},{l,b},{l,t} })
    end if
    ZoneCnt = ZoneCnt + 1
    if ZoneCnt > ZoneMax then
      ZoneCnt = 1
    end if
  end if
end procedure

global procedure AddZone
  (integer lft,integer rht,integer top,integer bot,integer cmd)
  Zone = append(Zone,{lft,rht,top,bot,cmd})
  for cnt = 1 to 2 do
    lft = lft - 1  rht = rht + 1
    top = top - 1  bot = bot + 1
    draw_line(0,{ {lft,top},{rht,top},{rht,bot},{lft,bot},{lft,top}})
  end for
  ZoneMax = length(Zone)
end procedure

